
/* initializing a variable outside of a function makes it global. The variable is active and available throughtout the programe 
Variables initialized inside a function are called local variables and lose their values once the program exits the function 
*/

import peasy.test.*;
import peasy.org.apache.commons.math.*;
import peasy.*;
import peasy.org.apache.commons.math.geometry.*;


PeasyCam cam;
import controlP5.*;
ControlP5 controlP5;

PMatrix3D currCameraMatrix;
PGraphics3D g3; 
float radSliderVal;
int p5Margin = 30;
int p5Distance = 22;
PFont  myHelvetica12 = createFont("Helvetica",12, true);
PFont  myHelvetica20 = createFont("Helvetica",20, true);

int buttonWidth = 150;
int buttonHeight = 20;



float constantMarginOnRows = 160;
float constantMarginOnColumns = 100;

  int colorInts[] = {
#EE4345,#E93F48,#E53B4C,#E0374F,#DA3452,#D53155,#CF2F57,#C82D5A,#C22C5C,#BB2B5D,#B52A5F,#AE2A60,#A72A61,#A02A62,#982A62,#912A62,#892A62,#822B62,#7A2B61,#732B60,#6B2B5F,#642B5E,#5C2A5C,#552A5A,#4E2958,#472855,#402852,#39274F,#32254C,#2C2449,#252345,#1F2142,#191F3E};
import java.util.Collections;
import java.lang.Math;
int radius =100;
int xPosition  = 20;

float blockWidth = 40;
float blockHeight = 40;   // initial 80

// we added these variables in class on tuesday

int cellWidth = 20;
int cellHeight = 50;
int colorLength = colorInts.length-1;
char AFLAG = 'C';
int rowMargin =180;
int columnMargin = 80;

/*Creating a two-dimensional array we are calling "Data Matrix", and initialize its values to null. 
A two-dimensional array is really nothing more than an array of arrays (a three-dimensional array 
is an array of arrays of arrays).
*/
float [][] standardDevMatrix = null;
float [][] averageMatrix = null;
float [][] tenDayArray = new float[200][366];

int nIndex = 1;
int oIndex = 0;
float progress=0;
float delta = 5.0;

// a variable to keep track of the MaxCount
float maxCount ;
float maxCount2;
//variables to represent the vertical and horizontal locations of the grid we will draw
int numRows, numColumns;

// crating a font of size 16 and helvetica 
PFont font = createFont( "Helvetica", 24, true);

// creating a table. Table objects store data with multiple rows and columns, much like in a traditional spreadsheet
Table myTable;
Table avTable;
float[][] averages;
int[][] avIndeces;
float[][] stDevs;
int[][] stDevIndeces;
float angle;


String[] a= new String[7];

//The Draw() processing function repeats itselfs continuously at 60 frames per second unless the frameRate is changed



int[] mySort(float[] a, int[] indeces){
     int j;
     boolean flag = true;   // set flag to true to begin first pass
     int temp;   //holding variable

     while ( flag )
         {
            flag= false;    //set flag to false awaiting a possible swap
            for( j=0;  j < a.length -1;  j++ )
            {
                   if ( a[ j ] < a[j+1] )   // change to > for ascending sort
                   {
//                           temp = num[ j ];                //swap elements
//                           num[ j ] = num[ j+1 ];
//                           num[ j+1 ] = temp;
                           swap(a,indeces, j, j+1);
                          flag = true;              //shows a swap occurred  
                  } 
            } 
      } 
  return indeces;
}

void swap(float[] a, int[] ind, int b, int c){
  int indTmp;
  float tmp;
  tmp = a[b];
  indTmp = ind[b];
  a[b] = a[c];
  ind[b]=ind[c];
  a[c] = tmp;
  ind[c] = indTmp;
}





